t / test-lib-functions.shon commit Merge branch 'rs/maint-config-use-labs' into maint (e8c2351)
   1# Library of functions shared by all tests scripts, included by
   2# test-lib.sh.
   3#
   4# Copyright (c) 2005 Junio C Hamano
   5#
   6# This program is free software: you can redistribute it and/or modify
   7# it under the terms of the GNU General Public License as published by
   8# the Free Software Foundation, either version 2 of the License, or
   9# (at your option) any later version.
  10#
  11# This program is distributed in the hope that it will be useful,
  12# but WITHOUT ANY WARRANTY; without even the implied warranty of
  13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  14# GNU General Public License for more details.
  15#
  16# You should have received a copy of the GNU General Public License
  17# along with this program.  If not, see http://www.gnu.org/licenses/ .
  18
  19# The semantics of the editor variables are that of invoking
  20# sh -c "$EDITOR \"$@\"" files ...
  21#
  22# If our trash directory contains shell metacharacters, they will be
  23# interpreted if we just set $EDITOR directly, so do a little dance with
  24# environment variables to work around this.
  25#
  26# In particular, quoting isn't enough, as the path may contain the same quote
  27# that we're using.
  28test_set_editor () {
  29        FAKE_EDITOR="$1"
  30        export FAKE_EDITOR
  31        EDITOR='"$FAKE_EDITOR"'
  32        export EDITOR
  33}
  34
  35test_set_index_version () {
  36    GIT_INDEX_VERSION="$1"
  37    export GIT_INDEX_VERSION
  38}
  39
  40test_decode_color () {
  41        awk '
  42                function name(n) {
  43                        if (n == 0) return "RESET";
  44                        if (n == 1) return "BOLD";
  45                        if (n == 30) return "BLACK";
  46                        if (n == 31) return "RED";
  47                        if (n == 32) return "GREEN";
  48                        if (n == 33) return "YELLOW";
  49                        if (n == 34) return "BLUE";
  50                        if (n == 35) return "MAGENTA";
  51                        if (n == 36) return "CYAN";
  52                        if (n == 37) return "WHITE";
  53                        if (n == 40) return "BLACK";
  54                        if (n == 41) return "BRED";
  55                        if (n == 42) return "BGREEN";
  56                        if (n == 43) return "BYELLOW";
  57                        if (n == 44) return "BBLUE";
  58                        if (n == 45) return "BMAGENTA";
  59                        if (n == 46) return "BCYAN";
  60                        if (n == 47) return "BWHITE";
  61                }
  62                {
  63                        while (match($0, /\033\[[0-9;]*m/) != 0) {
  64                                printf "%s<", substr($0, 1, RSTART-1);
  65                                codes = substr($0, RSTART+2, RLENGTH-3);
  66                                if (length(codes) == 0)
  67                                        printf "%s", name(0)
  68                                else {
  69                                        n = split(codes, ary, ";");
  70                                        sep = "";
  71                                        for (i = 1; i <= n; i++) {
  72                                                printf "%s%s", sep, name(ary[i]);
  73                                                sep = ";"
  74                                        }
  75                                }
  76                                printf ">";
  77                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
  78                        }
  79                        print
  80                }
  81        '
  82}
  83
  84nul_to_q () {
  85        perl -pe 'y/\000/Q/'
  86}
  87
  88q_to_nul () {
  89        perl -pe 'y/Q/\000/'
  90}
  91
  92q_to_cr () {
  93        tr Q '\015'
  94}
  95
  96q_to_tab () {
  97        tr Q '\011'
  98}
  99
 100qz_to_tab_space () {
 101        tr QZ '\011\040'
 102}
 103
 104append_cr () {
 105        sed -e 's/$/Q/' | tr Q '\015'
 106}
 107
 108remove_cr () {
 109        tr '\015' Q | sed -e 's/Q$//'
 110}
 111
 112# In some bourne shell implementations, the "unset" builtin returns
 113# nonzero status when a variable to be unset was not set in the first
 114# place.
 115#
 116# Use sane_unset when that should not be considered an error.
 117
 118sane_unset () {
 119        unset "$@"
 120        return 0
 121}
 122
 123test_tick () {
 124        if test -z "${test_tick+set}"
 125        then
 126                test_tick=1112911993
 127        else
 128                test_tick=$(($test_tick + 60))
 129        fi
 130        GIT_COMMITTER_DATE="$test_tick -0700"
 131        GIT_AUTHOR_DATE="$test_tick -0700"
 132        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 133}
 134
 135# Stop execution and start a shell. This is useful for debugging tests and
 136# only makes sense together with "-v".
 137#
 138# Be sure to remove all invocations of this command before submitting.
 139
 140test_pause () {
 141        if test "$verbose" = t; then
 142                "$SHELL_PATH" <&6 >&3 2>&4
 143        else
 144                error >&5 "test_pause requires --verbose"
 145        fi
 146}
 147
 148# Call test_commit with the arguments "<message> [<file> [<contents> [<tag>]]]"
 149#
 150# This will commit a file with the given contents and the given commit
 151# message, and tag the resulting commit with the given tag name.
 152#
 153# <file>, <contents>, and <tag> all default to <message>.
 154
 155test_commit () {
 156        notick= &&
 157        signoff= &&
 158        while test $# != 0
 159        do
 160                case "$1" in
 161                --notick)
 162                        notick=yes
 163                        ;;
 164                --signoff)
 165                        signoff="$1"
 166                        ;;
 167                *)
 168                        break
 169                        ;;
 170                esac
 171                shift
 172        done &&
 173        file=${2:-"$1.t"} &&
 174        echo "${3-$1}" > "$file" &&
 175        git add "$file" &&
 176        if test -z "$notick"
 177        then
 178                test_tick
 179        fi &&
 180        git commit $signoff -m "$1" &&
 181        git tag "${4:-$1}"
 182}
 183
 184# Call test_merge with the arguments "<message> <commit>", where <commit>
 185# can be a tag pointing to the commit-to-merge.
 186
 187test_merge () {
 188        test_tick &&
 189        git merge -m "$1" "$2" &&
 190        git tag "$1"
 191}
 192
 193# This function helps systems where core.filemode=false is set.
 194# Use it instead of plain 'chmod +x' to set or unset the executable bit
 195# of a file in the working directory and add it to the index.
 196
 197test_chmod () {
 198        chmod "$@" &&
 199        git update-index --add "--chmod=$@"
 200}
 201
 202# Unset a configuration variable, but don't fail if it doesn't exist.
 203test_unconfig () {
 204        git config --unset-all "$@"
 205        config_status=$?
 206        case "$config_status" in
 207        5) # ok, nothing to unset
 208                config_status=0
 209                ;;
 210        esac
 211        return $config_status
 212}
 213
 214# Set git config, automatically unsetting it after the test is over.
 215test_config () {
 216        test_when_finished "test_unconfig '$1'" &&
 217        git config "$@"
 218}
 219
 220test_config_global () {
 221        test_when_finished "test_unconfig --global '$1'" &&
 222        git config --global "$@"
 223}
 224
 225write_script () {
 226        {
 227                echo "#!${2-"$SHELL_PATH"}" &&
 228                cat
 229        } >"$1" &&
 230        chmod +x "$1"
 231}
 232
 233# Use test_set_prereq to tell that a particular prerequisite is available.
 234# The prerequisite can later be checked for in two ways:
 235#
 236# - Explicitly using test_have_prereq.
 237#
 238# - Implicitly by specifying the prerequisite tag in the calls to
 239#   test_expect_{success,failure,code}.
 240#
 241# The single parameter is the prerequisite tag (a simple word, in all
 242# capital letters by convention).
 243
 244test_set_prereq () {
 245        satisfied_prereq="$satisfied_prereq$1 "
 246}
 247satisfied_prereq=" "
 248lazily_testable_prereq= lazily_tested_prereq=
 249
 250# Usage: test_lazy_prereq PREREQ 'script'
 251test_lazy_prereq () {
 252        lazily_testable_prereq="$lazily_testable_prereq$1 "
 253        eval test_prereq_lazily_$1=\$2
 254}
 255
 256test_run_lazy_prereq_ () {
 257        script='
 258mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
 259(
 260        cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
 261)'
 262        say >&3 "checking prerequisite: $1"
 263        say >&3 "$script"
 264        test_eval_ "$script"
 265        eval_ret=$?
 266        rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
 267        if test "$eval_ret" = 0; then
 268                say >&3 "prerequisite $1 ok"
 269        else
 270                say >&3 "prerequisite $1 not satisfied"
 271        fi
 272        return $eval_ret
 273}
 274
 275test_have_prereq () {
 276        # prerequisites can be concatenated with ','
 277        save_IFS=$IFS
 278        IFS=,
 279        set -- $*
 280        IFS=$save_IFS
 281
 282        total_prereq=0
 283        ok_prereq=0
 284        missing_prereq=
 285
 286        for prerequisite
 287        do
 288                case "$prerequisite" in
 289                !*)
 290                        negative_prereq=t
 291                        prerequisite=${prerequisite#!}
 292                        ;;
 293                *)
 294                        negative_prereq=
 295                esac
 296
 297                case " $lazily_tested_prereq " in
 298                *" $prerequisite "*)
 299                        ;;
 300                *)
 301                        case " $lazily_testable_prereq " in
 302                        *" $prerequisite "*)
 303                                eval "script=\$test_prereq_lazily_$prerequisite" &&
 304                                if test_run_lazy_prereq_ "$prerequisite" "$script"
 305                                then
 306                                        test_set_prereq $prerequisite
 307                                fi
 308                                lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
 309                        esac
 310                        ;;
 311                esac
 312
 313                total_prereq=$(($total_prereq + 1))
 314                case "$satisfied_prereq" in
 315                *" $prerequisite "*)
 316                        satisfied_this_prereq=t
 317                        ;;
 318                *)
 319                        satisfied_this_prereq=
 320                esac
 321
 322                case "$satisfied_this_prereq,$negative_prereq" in
 323                t,|,t)
 324                        ok_prereq=$(($ok_prereq + 1))
 325                        ;;
 326                *)
 327                        # Keep a list of missing prerequisites; restore
 328                        # the negative marker if necessary.
 329                        prerequisite=${negative_prereq:+!}$prerequisite
 330                        if test -z "$missing_prereq"
 331                        then
 332                                missing_prereq=$prerequisite
 333                        else
 334                                missing_prereq="$prerequisite,$missing_prereq"
 335                        fi
 336                esac
 337        done
 338
 339        test $total_prereq = $ok_prereq
 340}
 341
 342test_declared_prereq () {
 343        case ",$test_prereq," in
 344        *,$1,*)
 345                return 0
 346                ;;
 347        esac
 348        return 1
 349}
 350
 351test_expect_failure () {
 352        test_start_
 353        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 354        test "$#" = 2 ||
 355        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 356        export test_prereq
 357        if ! test_skip "$@"
 358        then
 359                say >&3 "checking known breakage: $2"
 360                if test_run_ "$2" expecting_failure
 361                then
 362                        test_known_broken_ok_ "$1"
 363                else
 364                        test_known_broken_failure_ "$1"
 365                fi
 366        fi
 367        test_finish_
 368}
 369
 370test_expect_success () {
 371        test_start_
 372        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 373        test "$#" = 2 ||
 374        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 375        export test_prereq
 376        if ! test_skip "$@"
 377        then
 378                say >&3 "expecting success: $2"
 379                if test_run_ "$2"
 380                then
 381                        test_ok_ "$1"
 382                else
 383                        test_failure_ "$@"
 384                fi
 385        fi
 386        test_finish_
 387}
 388
 389# test_external runs external test scripts that provide continuous
 390# test output about their progress, and succeeds/fails on
 391# zero/non-zero exit code.  It outputs the test output on stdout even
 392# in non-verbose mode, and announces the external script with "# run
 393# <n>: ..." before running it.  When providing relative paths, keep in
 394# mind that all scripts run in "trash directory".
 395# Usage: test_external description command arguments...
 396# Example: test_external 'Perl API' perl ../path/to/test.pl
 397test_external () {
 398        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 399        test "$#" = 3 ||
 400        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 401        descr="$1"
 402        shift
 403        export test_prereq
 404        if ! test_skip "$descr" "$@"
 405        then
 406                # Announce the script to reduce confusion about the
 407                # test output that follows.
 408                say_color "" "# run $test_count: $descr ($*)"
 409                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 410                # to be able to use them in script
 411                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 412                # Run command; redirect its stderr to &4 as in
 413                # test_run_, but keep its stdout on our stdout even in
 414                # non-verbose mode.
 415                "$@" 2>&4
 416                if test "$?" = 0
 417                then
 418                        if test $test_external_has_tap -eq 0; then
 419                                test_ok_ "$descr"
 420                        else
 421                                say_color "" "# test_external test $descr was ok"
 422                                test_success=$(($test_success + 1))
 423                        fi
 424                else
 425                        if test $test_external_has_tap -eq 0; then
 426                                test_failure_ "$descr" "$@"
 427                        else
 428                                say_color error "# test_external test $descr failed: $@"
 429                                test_failure=$(($test_failure + 1))
 430                        fi
 431                fi
 432        fi
 433}
 434
 435# Like test_external, but in addition tests that the command generated
 436# no output on stderr.
 437test_external_without_stderr () {
 438        # The temporary file has no (and must have no) security
 439        # implications.
 440        tmp=${TMPDIR:-/tmp}
 441        stderr="$tmp/git-external-stderr.$$.tmp"
 442        test_external "$@" 4> "$stderr"
 443        test -f "$stderr" || error "Internal error: $stderr disappeared."
 444        descr="no stderr: $1"
 445        shift
 446        say >&3 "# expecting no stderr from previous command"
 447        if test ! -s "$stderr"
 448        then
 449                rm "$stderr"
 450
 451                if test $test_external_has_tap -eq 0; then
 452                        test_ok_ "$descr"
 453                else
 454                        say_color "" "# test_external_without_stderr test $descr was ok"
 455                        test_success=$(($test_success + 1))
 456                fi
 457        else
 458                if test "$verbose" = t
 459                then
 460                        output=$(echo; echo "# Stderr is:"; cat "$stderr")
 461                else
 462                        output=
 463                fi
 464                # rm first in case test_failure exits.
 465                rm "$stderr"
 466                if test $test_external_has_tap -eq 0; then
 467                        test_failure_ "$descr" "$@" "$output"
 468                else
 469                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 470                        test_failure=$(($test_failure + 1))
 471                fi
 472        fi
 473}
 474
 475# debugging-friendly alternatives to "test [-f|-d|-e]"
 476# The commands test the existence or non-existence of $1. $2 can be
 477# given to provide a more precise diagnosis.
 478test_path_is_file () {
 479        if ! test -f "$1"
 480        then
 481                echo "File $1 doesn't exist. $*"
 482                false
 483        fi
 484}
 485
 486test_path_is_dir () {
 487        if ! test -d "$1"
 488        then
 489                echo "Directory $1 doesn't exist. $*"
 490                false
 491        fi
 492}
 493
 494# Check if the directory exists and is empty as expected, barf otherwise.
 495test_dir_is_empty () {
 496        test_path_is_dir "$1" &&
 497        if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
 498        then
 499                echo "Directory '$1' is not empty, it contains:"
 500                ls -la "$1"
 501                return 1
 502        fi
 503}
 504
 505test_path_is_missing () {
 506        if test -e "$1"
 507        then
 508                echo "Path exists:"
 509                ls -ld "$1"
 510                if test $# -ge 1
 511                then
 512                        echo "$*"
 513                fi
 514                false
 515        fi
 516}
 517
 518# test_line_count checks that a file has the number of lines it
 519# ought to. For example:
 520#
 521#       test_expect_success 'produce exactly one line of output' '
 522#               do something >output &&
 523#               test_line_count = 1 output
 524#       '
 525#
 526# is like "test $(wc -l <output) = 1" except that it passes the
 527# output through when the number of lines is wrong.
 528
 529test_line_count () {
 530        if test $# != 3
 531        then
 532                error "bug in the test script: not 3 parameters to test_line_count"
 533        elif ! test $(wc -l <"$3") "$1" "$2"
 534        then
 535                echo "test_line_count: line count for $3 !$1 $2"
 536                cat "$3"
 537                return 1
 538        fi
 539}
 540
 541# This is not among top-level (test_expect_success | test_expect_failure)
 542# but is a prefix that can be used in the test script, like:
 543#
 544#       test_expect_success 'complain and die' '
 545#           do something &&
 546#           do something else &&
 547#           test_must_fail git checkout ../outerspace
 548#       '
 549#
 550# Writing this as "! git checkout ../outerspace" is wrong, because
 551# the failure could be due to a segv.  We want a controlled failure.
 552
 553test_must_fail () {
 554        "$@"
 555        exit_code=$?
 556        if test $exit_code = 0; then
 557                echo >&2 "test_must_fail: command succeeded: $*"
 558                return 1
 559        elif test $exit_code -gt 129 && test $exit_code -le 192; then
 560                echo >&2 "test_must_fail: died by signal: $*"
 561                return 1
 562        elif test $exit_code = 127; then
 563                echo >&2 "test_must_fail: command not found: $*"
 564                return 1
 565        elif test $exit_code = 126; then
 566                echo >&2 "test_must_fail: valgrind error: $*"
 567                return 1
 568        fi
 569        return 0
 570}
 571
 572# Similar to test_must_fail, but tolerates success, too.  This is
 573# meant to be used in contexts like:
 574#
 575#       test_expect_success 'some command works without configuration' '
 576#               test_might_fail git config --unset all.configuration &&
 577#               do something
 578#       '
 579#
 580# Writing "git config --unset all.configuration || :" would be wrong,
 581# because we want to notice if it fails due to segv.
 582
 583test_might_fail () {
 584        "$@"
 585        exit_code=$?
 586        if test $exit_code -gt 129 && test $exit_code -le 192; then
 587                echo >&2 "test_might_fail: died by signal: $*"
 588                return 1
 589        elif test $exit_code = 127; then
 590                echo >&2 "test_might_fail: command not found: $*"
 591                return 1
 592        fi
 593        return 0
 594}
 595
 596# Similar to test_must_fail and test_might_fail, but check that a
 597# given command exited with a given exit code. Meant to be used as:
 598#
 599#       test_expect_success 'Merge with d/f conflicts' '
 600#               test_expect_code 1 git merge "merge msg" B master
 601#       '
 602
 603test_expect_code () {
 604        want_code=$1
 605        shift
 606        "$@"
 607        exit_code=$?
 608        if test $exit_code = $want_code
 609        then
 610                return 0
 611        fi
 612
 613        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 614        return 1
 615}
 616
 617# test_cmp is a helper function to compare actual and expected output.
 618# You can use it like:
 619#
 620#       test_expect_success 'foo works' '
 621#               echo expected >expected &&
 622#               foo >actual &&
 623#               test_cmp expected actual
 624#       '
 625#
 626# This could be written as either "cmp" or "diff -u", but:
 627# - cmp's output is not nearly as easy to read as diff -u
 628# - not all diff versions understand "-u"
 629
 630test_cmp() {
 631        $GIT_TEST_CMP "$@"
 632}
 633
 634# test_cmp_bin - helper to compare binary files
 635
 636test_cmp_bin() {
 637        cmp "$@"
 638}
 639
 640# Call any command "$@" but be more verbose about its
 641# failure. This is handy for commands like "test" which do
 642# not output anything when they fail.
 643verbose () {
 644        "$@" && return 0
 645        echo >&2 "command failed: $(git rev-parse --sq-quote "$@")"
 646        return 1
 647}
 648
 649# Check if the file expected to be empty is indeed empty, and barfs
 650# otherwise.
 651
 652test_must_be_empty () {
 653        if test -s "$1"
 654        then
 655                echo "'$1' is not empty, it contains:"
 656                cat "$1"
 657                return 1
 658        fi
 659}
 660
 661# Tests that its two parameters refer to the same revision
 662test_cmp_rev () {
 663        git rev-parse --verify "$1" >expect.rev &&
 664        git rev-parse --verify "$2" >actual.rev &&
 665        test_cmp expect.rev actual.rev
 666}
 667
 668# Print a sequence of numbers or letters in increasing order.  This is
 669# similar to GNU seq(1), but the latter might not be available
 670# everywhere (and does not do letters).  It may be used like:
 671#
 672#       for i in $(test_seq 100)
 673#       do
 674#               for j in $(test_seq 10 20)
 675#               do
 676#                       for k in $(test_seq a z)
 677#                       do
 678#                               echo $i-$j-$k
 679#                       done
 680#               done
 681#       done
 682
 683test_seq () {
 684        case $# in
 685        1)      set 1 "$@" ;;
 686        2)      ;;
 687        *)      error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
 688        esac
 689        perl -le 'print for $ARGV[0]..$ARGV[1]' -- "$@"
 690}
 691
 692# This function can be used to schedule some commands to be run
 693# unconditionally at the end of the test to restore sanity:
 694#
 695#       test_expect_success 'test core.capslock' '
 696#               git config core.capslock true &&
 697#               test_when_finished "git config --unset core.capslock" &&
 698#               hello world
 699#       '
 700#
 701# That would be roughly equivalent to
 702#
 703#       test_expect_success 'test core.capslock' '
 704#               git config core.capslock true &&
 705#               hello world
 706#               git config --unset core.capslock
 707#       '
 708#
 709# except that the greeting and config --unset must both succeed for
 710# the test to pass.
 711#
 712# Note that under --immediate mode, no clean-up is done to help diagnose
 713# what went wrong.
 714
 715test_when_finished () {
 716        test_cleanup="{ $*
 717                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 718}
 719
 720# Most tests can use the created repository, but some may need to create more.
 721# Usage: test_create_repo <directory>
 722test_create_repo () {
 723        test "$#" = 1 ||
 724        error "bug in the test script: not 1 parameter to test-create-repo"
 725        repo="$1"
 726        mkdir -p "$repo"
 727        (
 728                cd "$repo" || error "Cannot setup test environment"
 729                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 730                error "cannot run git init -- have you built things yet?"
 731                mv .git/hooks .git/hooks-disabled
 732        ) || exit
 733}
 734
 735# This function helps on symlink challenged file systems when it is not
 736# important that the file system entry is a symbolic link.
 737# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
 738# symbolic link entry y to the index.
 739
 740test_ln_s_add () {
 741        if test_have_prereq SYMLINKS
 742        then
 743                ln -s "$1" "$2" &&
 744                git update-index --add "$2"
 745        else
 746                printf '%s' "$1" >"$2" &&
 747                ln_s_obj=$(git hash-object -w "$2") &&
 748                git update-index --add --cacheinfo 120000 $ln_s_obj "$2"
 749        fi
 750}
 751
 752# This function writes out its parameters, one per line
 753test_write_lines () {
 754        printf "%s\n" "$@"
 755}
 756
 757perl () {
 758        command "$PERL_PATH" "$@"
 759}
 760
 761# Is the value one of the various ways to spell a boolean true/false?
 762test_normalize_bool () {
 763        git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
 764}
 765
 766# Given a variable $1, normalize the value of it to one of "true",
 767# "false", or "auto" and store the result to it.
 768#
 769#     test_tristate GIT_TEST_HTTPD
 770#
 771# A variable set to an empty string is set to 'false'.
 772# A variable set to 'false' or 'auto' keeps its value.
 773# Anything else is set to 'true'.
 774# An unset variable defaults to 'auto'.
 775#
 776# The last rule is to allow people to set the variable to an empty
 777# string and export it to decline testing the particular feature
 778# for versions both before and after this change.  We used to treat
 779# both unset and empty variable as a signal for "do not test" and
 780# took any non-empty string as "please test".
 781
 782test_tristate () {
 783        if eval "test x\"\${$1+isset}\" = xisset"
 784        then
 785                # explicitly set
 786                eval "
 787                        case \"\$$1\" in
 788                        '')     $1=false ;;
 789                        auto)   ;;
 790                        *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
 791                        esac
 792                "
 793        else
 794                eval "$1=auto"
 795        fi
 796}
 797
 798# Exit the test suite, either by skipping all remaining tests or by
 799# exiting with an error. If "$1" is "auto", we then we assume we were
 800# opportunistically trying to set up some tests and we skip. If it is
 801# "true", then we report a failure.
 802#
 803# The error/skip message should be given by $2.
 804#
 805test_skip_or_die () {
 806        case "$1" in
 807        auto)
 808                skip_all=$2
 809                test_done
 810                ;;
 811        true)
 812                error "$2"
 813                ;;
 814        *)
 815                error "BUG: test tristate is '$1' (real error: $2)"
 816        esac
 817}
 818
 819# The following mingw_* functions obey POSIX shell syntax, but are actually
 820# bash scripts, and are meant to be used only with bash on Windows.
 821
 822# A test_cmp function that treats LF and CRLF equal and avoids to fork
 823# diff when possible.
 824mingw_test_cmp () {
 825        # Read text into shell variables and compare them. If the results
 826        # are different, use regular diff to report the difference.
 827        local test_cmp_a= test_cmp_b=
 828
 829        # When text came from stdin (one argument is '-') we must feed it
 830        # to diff.
 831        local stdin_for_diff=
 832
 833        # Since it is difficult to detect the difference between an
 834        # empty input file and a failure to read the files, we go straight
 835        # to diff if one of the inputs is empty.
 836        if test -s "$1" && test -s "$2"
 837        then
 838                # regular case: both files non-empty
 839                mingw_read_file_strip_cr_ test_cmp_a <"$1"
 840                mingw_read_file_strip_cr_ test_cmp_b <"$2"
 841        elif test -s "$1" && test "$2" = -
 842        then
 843                # read 2nd file from stdin
 844                mingw_read_file_strip_cr_ test_cmp_a <"$1"
 845                mingw_read_file_strip_cr_ test_cmp_b
 846                stdin_for_diff='<<<"$test_cmp_b"'
 847        elif test "$1" = - && test -s "$2"
 848        then
 849                # read 1st file from stdin
 850                mingw_read_file_strip_cr_ test_cmp_a
 851                mingw_read_file_strip_cr_ test_cmp_b <"$2"
 852                stdin_for_diff='<<<"$test_cmp_a"'
 853        fi
 854        test -n "$test_cmp_a" &&
 855        test -n "$test_cmp_b" &&
 856        test "$test_cmp_a" = "$test_cmp_b" ||
 857        eval "diff -u \"\$@\" $stdin_for_diff"
 858}
 859
 860# $1 is the name of the shell variable to fill in
 861mingw_read_file_strip_cr_ () {
 862        # Read line-wise using LF as the line separator
 863        # and use IFS to strip CR.
 864        local line
 865        while :
 866        do
 867                if IFS=$'\r' read -r -d $'\n' line
 868                then
 869                        # good
 870                        line=$line$'\n'
 871                else
 872                        # we get here at EOF, but also if the last line
 873                        # was not terminated by LF; in the latter case,
 874                        # some text was read
 875                        if test -z "$line"
 876                        then
 877                                # EOF, really
 878                                break
 879                        fi
 880                fi
 881                eval "$1=\$$1\$line"
 882        done
 883}